<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Module: communication</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Module: communication</h1>

    




<section>

<header>
    
        
            
        
    
</header>

<article>
    <div class="container-overview">
    
        
            <div class="description">Data transfer between the devices and convenience functions for actions</div>
        

        
            















<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line333">line 333</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    
    </div>

    

    

    

    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id=".deregisterUpdateListener"><span class="type-signature">(static) </span>deregisterUpdateListener<span class="signature">(sharedId)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Remove this socket from the list of listeners for updates of the SharedObject with the given sharedId
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The sharedId of the SharedObject to stop listening for</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line343">line 343</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".registerUpdateListener"><span class="type-signature">(static) </span>registerUpdateListener<span class="signature">(sharedId)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Register this socket to listen for updates of the SharedObject with the given sharedId
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The sharedId of the SharedObject to keep synchronized</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line353">line 353</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".sendCustomAction"><span class="type-signature">(static) </span>sendCustomAction<span class="signature">(to, identifier, &hellip;parameters)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Send a message that triggers a call of the function registered under the identifier. All other parameters are passed to the function.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>to</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The client or room name to send to</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>identifier</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The identifier of the custom function to call</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">any</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                    &lt;repeatable><br>
                
                </td>
            

            

            <td class="description last">The parameters to call the custom function with</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line409">line 409</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".sendMessage"><span class="type-signature">(static) </span>sendMessage<span class="signature">(to, content)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Send a message to a room or client, nothing happens if the receiver does not exist
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>to</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The client or room name to send to</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>content</code></td>
            

            <td class="type">
            
                
<span class="param-type">any</span>


            
            </td>

            

            

            <td class="description last">The content to sent, has to be an object conforming the messageSchema.json</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line395">line 395</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".sendSharedObject"><span class="type-signature">(static) </span>sendSharedObject<span class="signature">(to, sharedObject, independentCopyThere<span class="signature-attributes">opt</span>, deleteHere<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Sends the given SharedObject to the receiver using the addSharedObjects action
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>to</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">The client or room name to send to</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>sharedObject</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="SharedObject.html">SharedObject</a></span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">The SharedObject to send</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>independentCopyThere</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">If true, the SharedIds of the sendables are changed, so the receiver has a copy that is not synchronized with the original</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>deleteHere</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">If true, the SharedObject and the wrapped CreateJS object is removed after the transmission</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line429">line 429</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".sendSharedObjectDeletion"><span class="type-signature">(static) </span>sendSharedObjectDeletion<span class="signature">(to, sharedId)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Sends a message that triggers the deletion of the SharedObject on all receivers
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>to</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The client or room name to send to</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The sharedId of the SharedObject to delete</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line445">line 445</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id=".sendUpdate"><span class="type-signature">(static) </span>sendUpdate<span class="signature">(sharedId, propertyPath, oldValue, newValue, additionalInfo<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Send an update of the SharedObject with the given sharedId to the server
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The sharedId of the changed SharedObject</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>propertyPath</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The path from the createJsObject (excluding) to the changed property (including)</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>oldValue</code></td>
            

            <td class="type">
            
                
<span class="param-type">any</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The old value of the property</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>newValue</code></td>
            

            <td class="type">
            
                
<span class="param-type">any</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last">The new value of the property</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>additionalInfo</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last">Additional information, that is transmitted as is.E.g. additionalInfo.addHelpers is used to transmit SharedObject helpers, that are needed for the newValue.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line367">line 367</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-actions.html">actions</a></li><li><a href="module-communication.html">communication</a></li><li><a href="module-distributedDisplays.html">distributedDisplays</a></li><li><a href="module-rooms.html">rooms</a></li></ul><h3>Classes</h3><ul><li><a href="LinkedArea.html">LinkedArea</a></li><li><a href="SharedObject.html">SharedObject</a></li></ul><h3>Namespaces</h3><ul><li><a href="MTLG.html">MTLG</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Nov 13 2017 14:30:54 GMT+0100 (Mitteleuropäische Zeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>